<div class="row">
  <div class="col-sm-12"
       *ngFor="let announcement of announcements">
    <button class="btn btn-block btn-outline-info tile tile-announcement"
            (click)="openModal(show, announcement)">
      <div class="title">{{announcement.headline}}<br>
        <small>{{announcement.postedAt | date:'dd.MM.y HH:mm:ss'}}</small>
      </div>
    </button>
  </div>
  <div class="col-sm-12">
    <button class="btn btn-block btn-outline-info tile tile-announcement"
            (click)="openAddModal(add)">
      <fa-icon [icon]="faPencilAlt"></fa-icon>
      <span class="desc">New announcement</span>
    </button>
  </div>
</div>
<ng-template #add let-modal>
  <form [formGroup]="announcementForm" (ngSubmit)="saveAnnouncement(modal)">
    <div class="modal-header">
      <h4 class="modal-title">Write a new Announcement</h4>
      <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <label for="inputHeadline">Headline</label>
        <input type="text" formControlName="headline" class="form-control" id="inputHeadline"
               placeholder="A click bait like headline!">
      </div>
      <div class="form-group">
        <label for="inputText">Text</label>
        <textarea class="form-control" id="inputText" formControlName="text" rows="10"></textarea>
      </div>
      <markdown [data]="announcementForm.get('text').value"></markdown>
      <ngb-alert *ngIf="uploadingMessage" type="warning" (close)="uploadingMessage = null">{{uploadingMessage}}
      </ngb-alert>
    </div>
    <div class="modal-footer">
      <button type="submit" [disabled]="!announcementForm.valid" class="btn btn-primary">Save</button>
    </div>
  </form>
</ng-template>

<ng-template #show let-modal>
  <form [formGroup]="announcementForm" (ngSubmit)="updateAnnouncement(modal)">
    <div class="modal-header">
      <h4 class="modal-title">
        {{announcementForm.get('headline').value}} - Id: {{announcementForm.get('id').value}}
        <h6>{{announcementForm.get('postedAt').value | date:'dd.MM.y HH:mm:ss'}}</h6>
        <button type="button" class="btn btn-danger btn-sm"
                (click)="deleteAnnouncement(announcementForm.get('id').value, modal)">
          Delete announcement
        </button>
      </h4>
      <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div>
        <markdown [data]="announcementForm.get('text').value"></markdown>
      </div>
    </div>
    <div class="modal-body">
      <button type="button"
              class="btn btn-warning btn-sm"
              *ngIf="!editMode"
              (click)="editMode=!editMode">
        Edit announcement
      </button>
      <ng-container *ngIf="editMode">
        <div class="form-group">
          <label for="headlineEdit">Headline:</label>
          <input type="text" formControlName="headline" class="form-control" id="headlineEdit"/>
        </div>
        <div class="form-group">
          <label for="textEdit">Text:</label>
          <textarea type="text" formControlName="text" class="form-control" id="textEdit" rows="5"></textarea>
        </div>
        <button class="btn btn-success btn-sm"
                [disabled]="!announcementForm.valid"
                type="submit">
          Save announcement
        </button>
      </ng-container>
    </div>
    <div class="modal-footer" style="justify-content: flex-start">
      <label for="inputTimeout">Timeout in minutes (0 = permanently stopped)</label>
      <input type="number"
             formControlName="currentTimeout"
             name="timeout"
             class="form-control"
             id="inputTimeout"/>
      <button type="button"
              class="btn btn-info"
              (click)="activateAnnouncement(announcementForm.get('id').value, announcementForm.get('currentTimeout').value);modal.close('activated announcement');">
        Show at frontend
      </button>
    </div>
  </form>
</ng-template>
